﻿Public Class AMEDAS
    ' 構造体宣言
    Public Structure Amedas
        ' ***********メンバ変数*********************
        Public ID As Integer
        Public name As String
        ' ***********メソッド*********************
        ''' <summary>
        ''' アクセスに必要なURLを作成する
        ''' </summary>
        ''' <param name="t"></param>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public Function GetURL_10min(ByVal t As Date)
            Return "http://www.data.jma.go.jp/obd/stats/etrn/view/10min_s1.php?&block_no=" + _
                Me.ID.ToString + "&year=" + t.Year.ToString + "&month=" + t.Month.ToString + "&day=" + t.Day.ToString + "&elm=minutes&view=" ' URL作成
        End Function
        ''' <summary>
        ''' アメダスのURLから基地局IDを取得する
        ''' </summary>
        ''' <param name="url">URLの文字列</param>
        ''' <returns>取得に成功すればIDが返ります。失敗すれば0が返されます。</returns>
        ''' <remarks></remarks>
        Public Function GetAMEDASid(ByVal url As String) As Integer
            Dim id As Integer
            Dim success As Boolean = False
            Dim r As New System.Text.RegularExpressions.Regex("block_no=\d+", System.Text.RegularExpressions.RegexOptions.IgnoreCase) ' Regexオブジェクトを作成 
            Dim m As System.Text.RegularExpressions.Match = r.Match(url)    ' url文字列内で正規表現と一致する対象を1つ検索 

            If m.Success Then                                               ' もし、ヒットしたら処理を行う
                success = Integer.TryParse(m.Value.Split("=")(1), id)       ' スプリットで文字列を切り出して、IDのみを抽出
            End If
            If success = False Then id = 0 ' 失敗していた時の処置
            GetAMEDASid = id
        End Function
        ''' <summary>
        ''' コンストラクタ
        ''' </summary>
        ''' <param name="_ID"></param>
        ''' <param name="_name"></param>
        ''' <remarks></remarks>
        Sub New(ByRef _ID As Integer, ByVal _name As String)
            Me.ID = _ID
            Me.name = _name
        End Sub
    End Structure

End Class
